<template>
  <headless-transition-root :show="show" as="template">
    <headless-dialog
      class="ui-dialog prose fixed z-50 leading-snug md:prose-lg lg:prose-xl"
      @close="close"
    >
      <!-- backdrop-->
      <headless-transition-child
        as="template"
        enter="transition-opacity ease-linear duration-300"
        enter-from="opacity-0"
        enter-to="opacity-100"
        leave="transition-opacity ease-linear duration-300"
        leave-from="opacity-100"
        leave-to="opacity-0"
      >
        <div
          class="fixed inset-0 bg-black/50 backdrop-blur-xl backdrop-grayscale supports-backdrop-blur:bg-black/30"
          aria-hidden="true"
        />
      </headless-transition-child>

      <!-- dialog content -->
      <div class="fixed inset-0 overflow-y-auto p-4" @click.self="close">
        <div class="flex min-h-full items-center justify-center">
          <headless-transition-child
            as="template"
            enter="duration-300 ease-out"
            enter-from="opacity-0 scale-95"
            enter-to="opacity-100 scale-100"
            leave="duration-200 ease-in"
            leave-from="opacity-100 scale-100"
            leave-to="opacity-0 scale-95"
          >
            <headless-dialog-panel
              class="min-w-[min(24rem,_100%)] max-w-lg rounded-lg bg-white p-4 shadow-lg lg:max-w-xl xl:max-w-2xl xl:p-5"
            >
              <div
                class="flex flex-col items-center text-center sm:flex-row sm:items-start sm:gap-4 sm:text-start"
              >
                <div
                  aria-hidden="true"
                  class="flex size-12 flex-shrink-0 items-center justify-center rounded-full p-2 empty:hidden sm:mt-2 md:mt-3 lg:size-14"
                  :class="{
                    'bg-gray-100 text-gray-600':
                      !info && !success && !warning && !danger,
                    'bg-violet-100 text-violet-500':
                      info && !success && !warning && !danger,
                    'bg-green-100 text-green-600':
                      success && !warning && !danger,
                    'bg-yellow-200 text-yellow-900': warning && !danger,
                    'bg-red-100 text-red-600': danger,
                  }"
                >
                  <slot name="icon">
                    <information-circle-icon v-if="info" class="stroke-2" />
                    <check-circle-icon v-else-if="success" class="stroke-2" />
                    <exclamation-triangle-icon
                      v-else-if="warning || danger"
                      class="stroke-2"
                    />
                  </slot>
                </div>
                <div>
                  <headless-dialog-title class="!my-4">
                    <slot name="title" :title="title">
                      {{ title }}
                    </slot>
                  </headless-dialog-title>
                  <headless-dialog-description
                    v-if="description"
                    class="font-medium leading-normal text-gray-600"
                  >
                    {{ description }}
                  </headless-dialog-description>

                  <slot :content="content">
                    <p>
                      {{ content }}
                    </p>
                  </slot>
                </div>
              </div>

              <div
                class="mt-6 flex flex-col gap-6 sm:mt-8 sm:flex-row sm:flex-wrap sm:justify-end"
              >
                <slot name="buttons" :close="close" />
              </div>
            </headless-dialog-panel>
          </headless-transition-child>
        </div>
      </div>
    </headless-dialog>
  </headless-transition-root>
</template>

<script lang="ts" setup>
import {
  TransitionRoot as HeadlessTransitionRoot,
  TransitionChild as HeadlessTransitionChild,
  Dialog as HeadlessDialog,
  DialogPanel as HeadlessDialogPanel,
  DialogTitle as HeadlessDialogTitle,
  DialogDescription as HeadlessDialogDescription,
} from '@headlessui/vue'
import {
  CheckCircleIcon,
  ExclamationTriangleIcon,
  InformationCircleIcon,
} from '@heroicons/vue/24/outline'

defineOptions({
  name: 'UiDialog',
})

defineProps({
  /** Whether to show the dialog. */
  show: {
    type: Boolean,
    default: false,
  },
  /** A title used as `aria-labelledby` for the dialog. */
  title: {
    type: String,
    default: '',
  },
  /** A description used as `aria-describedby` for the dialog. */
  description: {
    type: String,
    default: null,
  },
  /** The actual content of the dialog. Can also be passed via the `content` slot. */
  content: {
    type: String,
    default: '',
  },
  info: {
    type: Boolean,
    default: false,
  },
  success: {
    type: Boolean,
    default: false,
  },
  warning: {
    type: Boolean,
    default: false,
  },
  danger: {
    type: Boolean,
    default: false,
  },
})

const emit = defineEmits(['close'])

const close = () => emit('close')
</script>
